<?php

namespace Drupal\renderkit\EntityToEntities;

/**
 * Represents a one-to-many relation between entities.
 */
interface EntityToEntitiesInterface {

  /**
   * @return string
   */
  public function getTargetEntityType();

  /**
   * @param string $entityType
   *   The source entity type.
   * @param object[] $entities
   *   Format: $[$sourceEntityDelta] = $sourceEntity
   *
   * @return object[][]
   *   Format: $[$sourceEntityDelta][$targetEntityDelta] = $targetEntity
   */
  public function entitiesGetRelated($entityType, array $entities);

  /**
   * @param string $entityType
   *   The source entity type.
   * @param object $entity
   *   The source entity.
   *
   * @return object[]
   *   Format: $[$targetEntityDelta] = $targetEntity
   */
  public function entityGetRelated($entityType, $entity);
}
