<?php

namespace Drupal\renderkit\EntityToEntity;

/**
 * Represents a one-to-one relation between entities.
 */
interface EntityToEntityInterface {

  /**
   * Gets the entity type of the referenced entities.
   *
   * @return string
   */
  public function getTargetType();

  /**
   * @param string $entityType
   *   The source entity type.
   * @param object[] $entities
   *   Format: $[$sourceEntityDelta] = $sourceEntity
   *
   * @return object[]
   *   Format: $[$sourceEntityDelta] = $targetEntity
   */
  public function entitiesGetRelated($entityType, array $entities);

  /**
   * @param string $entityType
   *   The source entity type.
   * @param object $entity
   *   THe source entity.
   *
   * @return object|null
   *   The target entity, or NULL if none found.
   */
  public function entityGetRelated($entityType, $entity);
}
